#pragma once

class IBaseLock
{
public:
	virtual void Lock() = 0;
	virtual void UnLock() = 0;
};

class CAutoLock
{
public:
	CAutoLock(IBaseLock *p)
	{
		m_pBaseLock = p;
		m_pBaseLock->Lock();
	}

	~CAutoLock(void)
	{
		m_pBaseLock->UnLock();
	}
private:
	CAutoLock(){}
	IBaseLock *m_pBaseLock;
};

