#pragma once
#include <stdlib.h>
#include <string.h>

template<class  T>
class CDynamicAry
{
public:
	CDynamicAry(void)
	{
		m_pTay = NULL;
		FreeIdleTrunk();
	}
    ~CDynamicAry(void){FreeIdleTrunk();}

	void Add(T _Tay)
	{
		if (m_pTay)
		{
            //如果动态数组已经满了则重新开辟一块内存
			if (IsFull())
			{
				if (m_iSizeAll < 50)
				{
					m_iSizeAll = m_iSizeAll + m_iSizeAll/2;
				}
				else if (m_iSizeAll < 100)
				{
					m_iSizeAll = m_iSizeAll + m_iSizeAll/4;
				}
				else
				{
					m_iSizeAll = m_iSizeAll + m_iSizeAll/8;
				}

				m_pTay = (T*)realloc(m_pTay,sizeof(T)*m_iSizeAll);
			}
		}
		else
		{
			m_pTay = (T*)malloc(sizeof(T)*10);
			m_iSizeAll     = 10;
		}

		//插入新数据
		m_pTay[m_iSizeNod++] = _Tay;
	}

	//删除指定元素,分需要删除的元素是在当前元素前中后分别处理
	void RemoveFromIndex(int iIndex) 
	{
		if (iIndex > m_iCurrentNode)
		{
			m_iSizeNod--;
			m_pTay[iIndex] = m_pTay[m_iSizeNod];
		}
		else if (iIndex == m_iCurrentNode)
		{
			m_iSizeNod--;
			m_iCurrentNode--;
			m_pTay[iIndex] = m_pTay[m_iSizeNod];
		}
		else
		{
			m_iSizeNod--;
			m_pTay[iIndex] = m_pTay[m_iCurrentNode];
			m_pTay[m_iCurrentNode] = m_pTay[m_iSizeNod];
			m_iCurrentNode--;
		}
	}

	int  IsFull()                            
	{
		return m_iSizeNod == m_iSizeAll;
	}
	int GetSizeNode()                       
	{
		return m_iSizeNod;
	}
	void  SetSizeNode(int iSizeNode) 
	{
		m_iSizeNod= iSizeNode;
	}
	void  SetCurrentIndex(int iCurrentNode) 
	{
		m_iCurrentNode= iCurrentNode;
	}

	void  SetMaxSize(int iMaxSize) 
	{
		m_iMaxSize= iMaxSize;
	}
	int GetCurrentIndex()                     
	{
		return m_iCurrentNode;
	}
	T &GetNodeFromIndex(int iIndex)         
	{
		return m_pTay[iIndex];
	}
	void Swap(int iIndex1,int iIndex2)
	{
		T Tay = m_pTay[iIndex2];
		m_pTay[iIndex2] =  m_pTay[iIndex1];
		m_pTay[iIndex1] = Tay;
	}
	void FreeIdleTrunk()
	{
		if (m_pTay)
			free(m_pTay);

		m_pTay = NULL;
		m_iSizeAll = 0;
		m_iSizeNod = 0;
		m_iCurrentNode = -1;
	}
	void ReBindDyamicAry()
	{
		//收缩内存空间，防止有过多的内存浪费
		//当所有元素均被删除后释放所有内存空间
		if (0 == m_iSizeNod && m_iSizeAll > 0)
		{
			FreeIdleTrunk();
			return;
		}

		if ( m_iSizeAll > 20 && m_iSizeNod < m_iSizeAll/2)
		{	
			m_iSizeAll = m_iSizeNod<10?10:m_iSizeNod;
			T* _pTay = (T*)malloc(sizeof(T)*m_iSizeAll);
			if (_pTay)
			{
				memcpy(_pTay,m_pTay,sizeof(T)*m_iSizeNod);
				free(m_pTay);
				m_pTay = _pTay;
			}
		} 
	}
private:
	T    *m_pTay;
	int m_iSizeAll;
	int m_iSizeNod;
	int m_iCurrentNode;
    int m_iMaxSize;
};
